(module
  (memory 17
    (segment 4 "@\00\10\00")
  )
  (export "memory" memory)
  (type $FUNCSIG$v (func))
  (type $FUNCSIG$vi (func (param i32)))
  (import $abort "env" "abort")
  (import $exit "env" "exit" (param i32))
  (export "gcd_ll" $gcd_ll)
  (export "powmod_ll" $powmod_ll)
  (export "facts" $facts)
  (export "main" $main)
  (func $gcd_ll (param $0 i64) (param $1 i64) (result i32)
    (block $label$0
      (block $label$1
        (br_if $label$1
          (i64.eqz
            (get_local $1)
          )
        )
        (loop $label$3 $label$2
          (br_if $label$0
            (i64.eqz
              (set_local $0
                (i64.rem_u
                  (get_local $0)
                  (get_local $1)
                )
              )
            )
          )
          (br_if $label$2
            (i64.ne
              (set_local $1
                (i64.rem_u
                  (get_local $1)
                  (get_local $0)
                )
              )
              (i64.const 0)
            )
          )
        )
      )
      (return
        (i32.wrap/i64
          (get_local $0)
        )
      )
    )
    (i32.wrap/i64
      (get_local $1)
    )
  )
  (func $powmod_ll (param $0 i64) (param $1 i32) (param $2 i64) (result i64)
    (local $3 i32)
    (local $4 i32)
    (local $5 i64)
    (set_local $5
      (i64.const 1)
    )
    (block $label$0
      (block $label$1
        (br_if $label$1
          (i32.eqz
            (get_local $1)
          )
        )
        (set_local $3
          (i32.const 0)
        )
        (set_local $4
          (get_local $1)
        )
        (loop $label$3 $label$2
          (set_local $3
            (i32.add
              (get_local $3)
              (i32.const 1)
            )
          )
          (br_if $label$2
            (set_local $4
              (i32.shr_u
                (get_local $4)
                (i32.const 1)
              )
            )
          )
        )
        (br_if $label$0
          (i32.lt_s
            (i32.add
              (get_local $3)
              (i32.const -1)
            )
            (i32.const 1)
          )
        )
        (set_local $5
          (get_local $0)
        )
        (loop $label$5 $label$4
          (set_local $5
            (i64.rem_u
              (i64.mul
                (get_local $5)
                (get_local $5)
              )
              (get_local $2)
            )
          )
          (block $label$6
            (br_if $label$6
              (i32.eqz
                (i32.and
                  (i32.shl
                    (i32.const 1)
                    (i32.add
                      (get_local $3)
                      (i32.const -2)
                    )
                  )
                  (get_local $1)
                )
              )
            )
            (set_local $5
              (i64.rem_u
                (i64.mul
                  (get_local $5)
                  (get_local $0)
                )
                (get_local $2)
              )
            )
          )
          (br_if $label$4
            (i32.gt_s
              (set_local $3
                (i32.add
                  (get_local $3)
                  (i32.const -1)
                )
              )
              (i32.const 1)
            )
          )
        )
      )
      (return
        (get_local $5)
      )
    )
    (get_local $0)
  )
  (func $facts (param $0 i64) (param $1 i32) (param $2 i32) (param $3 i32)
    (local $4 i64)
    (local $5 i64)
    (local $6 i64)
    (local $7 i32)
    (local $8 i64)
    (local $9 i64)
    (local $10 i32)
    (local $11 i32)
    (local $12 i64)
    (local $13 i64)
    (local $14 i64)
    (local $15 i32)
    (local $16 i32)
    (local $17 i32)
    (set_local $5
      (i64.add
        (set_local $4
          (i64.extend_s/i32
            (get_local $1)
          )
        )
        (i64.const 1)
      )
    )
    (set_local $15
      (i32.const 16)
    )
    (set_local $17
      (i32.const 0)
    )
    (set_local $16
      (i32.const 1)
    )
    (set_local $7
      (i32.const 1)
    )
    (set_local $8
      (i64.const 1)
    )
    (set_local $13
      (set_local $9
        (i64.extend_s/i32
          (get_local $2)
        )
      )
    )
    (loop $label$1 $label$0
      (set_local $6
        (get_local $13)
      )
      (set_local $13
        (get_local $5)
      )
      (set_local $14
        (i64.const 1)
      )
      (block $label$2
        (br_if $label$2
          (i32.eqz
            (get_local $3)
          )
        )
        (set_local $1
          (i32.const -1)
        )
        (set_local $10
          (i32.const 1)
        )
        (set_local $11
          (get_local $3)
        )
        (loop $label$4 $label$3
          (set_local $10
            (i32.add
              (set_local $2
                (get_local $10)
              )
              (i32.const 1)
            )
          )
          (set_local $1
            (i32.add
              (get_local $1)
              (i32.const 1)
            )
          )
          (br_if $label$3
            (set_local $11
              (i32.shr_u
                (get_local $11)
                (i32.const 1)
              )
            )
          )
        )
        (block $label$5
          (block $label$6
            (br_if $label$6
              (i32.lt_s
                (get_local $1)
                (i32.const 1)
              )
            )
            (set_local $12
              (get_local $6)
            )
            (loop $label$8 $label$7
              (set_local $12
                (i64.rem_u
                  (i64.mul
                    (get_local $12)
                    (get_local $12)
                  )
                  (get_local $0)
                )
              )
              (block $label$9
                (br_if $label$9
                  (i32.eqz
                    (i32.and
                      (i32.shl
                        (i32.const 1)
                        (i32.add
                          (get_local $2)
                          (i32.const -2)
                        )
                      )
                      (get_local $3)
                    )
                  )
                )
                (set_local $12
                  (i64.rem_u
                    (i64.mul
                      (get_local $12)
                      (get_local $6)
                    )
                    (get_local $0)
                  )
                )
              )
              (br_if $label$7
                (i32.gt_s
                  (set_local $2
                    (i32.add
                      (get_local $2)
                      (i32.const -1)
                    )
                  )
                  (i32.const 1)
                )
              )
              (br $label$5)
            )
          )
          (set_local $12
            (get_local $6)
          )
        )
        (set_local $13
          (i64.add
            (get_local $12)
            (get_local $4)
          )
        )
        (set_local $1
          (i32.const -1)
        )
        (set_local $10
          (i32.const 1)
        )
        (set_local $11
          (get_local $3)
        )
        (loop $label$11 $label$10
          (set_local $10
            (i32.add
              (set_local $2
                (get_local $10)
              )
              (i32.const 1)
            )
          )
          (set_local $1
            (i32.add
              (get_local $1)
              (i32.const 1)
            )
          )
          (br_if $label$10
            (set_local $11
              (i32.shr_u
                (get_local $11)
                (i32.const 1)
              )
            )
          )
        )
        (block $label$12
          (block $label$13
            (br_if $label$13
              (i32.lt_s
                (get_local $1)
                (i32.const 1)
              )
            )
            (set_local $12
              (get_local $9)
            )
            (loop $label$15 $label$14
              (set_local $12
                (i64.rem_u
                  (i64.mul
                    (get_local $12)
                    (get_local $12)
                  )
                  (get_local $0)
                )
              )
              (block $label$16
                (br_if $label$16
                  (i32.eqz
                    (i32.and
                      (i32.shl
                        (i32.const 1)
                        (i32.add
                          (get_local $2)
                          (i32.const -2)
                        )
                      )
                      (get_local $3)
                    )
                  )
                )
                (set_local $12
                  (i64.rem_u
                    (i64.mul
                      (get_local $12)
                      (get_local $9)
                    )
                    (get_local $0)
                  )
                )
              )
              (br_if $label$14
                (i32.gt_s
                  (set_local $2
                    (i32.add
                      (get_local $2)
                      (i32.const -1)
                    )
                  )
                  (i32.const 1)
                )
              )
              (br $label$12)
            )
          )
          (set_local $12
            (get_local $9)
          )
        )
        (set_local $14
          (i64.add
            (get_local $12)
            (get_local $4)
          )
        )
        (set_local $1
          (i32.const -1)
        )
        (set_local $10
          (i32.const 1)
        )
        (set_local $11
          (get_local $3)
        )
        (loop $label$18 $label$17
          (set_local $10
            (i32.add
              (set_local $2
                (get_local $10)
              )
              (i32.const 1)
            )
          )
          (set_local $1
            (i32.add
              (get_local $1)
              (i32.const 1)
            )
          )
          (br_if $label$17
            (set_local $11
              (i32.shr_u
                (get_local $11)
                (i32.const 1)
              )
            )
          )
        )
        (br_if $label$2
          (i32.lt_s
            (get_local $1)
            (i32.const 1)
          )
        )
        (set_local $12
          (get_local $14)
        )
        (loop $label$20 $label$19
          (set_local $12
            (i64.rem_u
              (i64.mul
                (get_local $12)
                (get_local $12)
              )
              (get_local $0)
            )
          )
          (block $label$21
            (br_if $label$21
              (i32.eqz
                (i32.and
                  (i32.shl
                    (i32.const 1)
                    (i32.add
                      (get_local $2)
                      (i32.const -2)
                    )
                  )
                  (get_local $3)
                )
              )
            )
            (set_local $12
              (i64.rem_u
                (i64.mul
                  (get_local $12)
                  (get_local $14)
                )
                (get_local $0)
              )
            )
          )
          (br_if $label$19
            (i32.gt_s
              (set_local $2
                (i32.add
                  (get_local $2)
                  (i32.const -1)
                )
              )
              (i32.const 1)
            )
          )
        )
        (set_local $14
          (get_local $12)
        )
      )
      (set_local $8
        (i64.rem_u
          (i64.mul
            (i64.and
              (select
                (i64.sub
                  (get_local $13)
                  (set_local $9
                    (i64.add
                      (get_local $14)
                      (get_local $4)
                    )
                  )
                )
                (i64.sub
                  (get_local $9)
                  (get_local $13)
                )
                (i64.gt_u
                  (get_local $13)
                  (get_local $9)
                )
              )
              (i64.const 4294967295)
            )
            (i64.and
              (get_local $8)
              (i64.const 4294967295)
            )
          )
          (get_local $0)
        )
      )
      (block $label$22
        (br_if $label$22
          (i32.ne
            (get_local $7)
            (get_local $16)
          )
        )
        (set_local $12
          (i64.and
            (get_local $8)
            (i64.const 4294967295)
          )
        )
        (set_local $17
          (i32.add
            (get_local $17)
            (i32.const 1)
          )
        )
        (block $label$23
          (br_if $label$23
            (i64.eqz
              (get_local $0)
            )
          )
          (set_local $14
            (get_local $0)
          )
          (loop $label$25 $label$24
            (br_if $label$25
              (i64.eqz
                (set_local $12
                  (i64.rem_u
                    (get_local $12)
                    (get_local $14)
                  )
                )
              )
            )
            (br_if $label$24
              (i64.ne
                (set_local $14
                  (i64.rem_u
                    (get_local $14)
                    (get_local $12)
                  )
                )
                (i64.const 0)
              )
            )
            (br $label$23)
          )
          (set_local $12
            (get_local $14)
          )
        )
        (set_local $16
          (i32.add
            (get_local $17)
            (get_local $16)
          )
        )
        (br_if $label$22
          (i32.eq
            (set_local $2
              (i32.wrap/i64
                (get_local $12)
              )
            )
            (i32.const 1)
          )
        )
        (i32.store
          (get_local $15)
          (get_local $2)
        )
        (br_if $label$1
          (i64.eq
            (set_local $0
              (i64.div_u
                (get_local $0)
                (i64.and
                  (get_local $12)
                  (i64.const 4294967295)
                )
              )
            )
            (i64.const 1)
          )
        )
        (set_local $15
          (i32.add
            (get_local $15)
            (i32.const 4)
          )
        )
      )
      (br_if $label$0
        (i32.lt_s
          (set_local $7
            (i32.add
              (get_local $7)
              (i32.const 1)
            )
          )
          (i32.const 10000)
        )
      )
    )
  )
  (func $main (result i32)
    (call $facts
      (i64.const 134217727)
      (i32.const -1)
      (i32.const 3)
      (i32.const 27)
    )
    (block $label$0
      (br_if $label$0
        (i32.ne
          (i32.load offset=16
            (i32.const 0)
          )
          (i32.const 7)
        )
      )
      (br_if $label$0
        (i32.ne
          (i32.load offset=20
            (i32.const 0)
          )
          (i32.const 73)
        )
      )
      (br_if $label$0
        (i32.ne
          (i32.load offset=24
            (i32.const 0)
          )
          (i32.const 262657)
        )
      )
      (call_import $exit
        (i32.const 0)
      )
      (unreachable)
    )
    (call_import $abort)
    (unreachable)
  )
)
