(module
  (memory 17
    (segment 4 "\10\00\10\00")
  )
  (export "memory" memory)
  (type $FUNCSIG$v (func))
  (type $FUNCSIG$vi (func (param i32)))
  (import $abort "env" "abort")
  (import $exit "env" "exit" (param i32))
  (export "float_min1" $float_min1)
  (export "float_min2" $float_min2)
  (export "float_max1" $float_max1)
  (export "float_max2" $float_max2)
  (export "double_min1" $double_min1)
  (export "double_min2" $double_min2)
  (export "double_max1" $double_max1)
  (export "double_max2" $double_max2)
  (export "main" $main)
  (func $float_min1 (param $0 f32) (param $1 f32) (result f32)
    (select
      (get_local $0)
      (get_local $1)
      (f32.lt
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $float_min2 (param $0 f32) (param $1 f32) (result f32)
    (select
      (get_local $0)
      (get_local $1)
      (f32.le
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $float_max1 (param $0 f32) (param $1 f32) (result f32)
    (select
      (get_local $0)
      (get_local $1)
      (f32.gt
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $float_max2 (param $0 f32) (param $1 f32) (result f32)
    (select
      (get_local $0)
      (get_local $1)
      (f32.ge
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $double_min1 (param $0 f64) (param $1 f64) (result f64)
    (select
      (get_local $0)
      (get_local $1)
      (f64.lt
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $double_min2 (param $0 f64) (param $1 f64) (result f64)
    (select
      (get_local $0)
      (get_local $1)
      (f64.le
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $double_max1 (param $0 f64) (param $1 f64) (result f64)
    (select
      (get_local $0)
      (get_local $1)
      (f64.gt
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $double_max2 (param $0 f64) (param $1 f64) (result f64)
    (select
      (get_local $0)
      (get_local $1)
      (f64.ge
        (get_local $0)
        (get_local $1)
      )
    )
  )
  (func $main (result i32)
    (block $label$0
      (block $label$1
        (br_if $label$1
          (f32.ne
            (call $float_min1
              (f32.const 0)
              (f32.const -1)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min1
              (f32.const -1)
              (f32.const 0)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min1
              (f32.const 0)
              (f32.const 1)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min1
              (f32.const 1)
              (f32.const 0)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min1
              (f32.const -1)
              (f32.const 1)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min1
              (f32.const 1)
              (f32.const -1)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max1
              (f32.const 0)
              (f32.const -1)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max1
              (f32.const -1)
              (f32.const 0)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max1
              (f32.const 0)
              (f32.const 1)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max1
              (f32.const 1)
              (f32.const 0)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max1
              (f32.const -1)
              (f32.const 1)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max1
              (f32.const 1)
              (f32.const -1)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min2
              (f32.const 0)
              (f32.const -1)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min2
              (f32.const -1)
              (f32.const 0)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min2
              (f32.const 0)
              (f32.const 1)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min2
              (f32.const 1)
              (f32.const 0)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min2
              (f32.const -1)
              (f32.const 1)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_min2
              (f32.const 1)
              (f32.const -1)
            )
            (f32.const -1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max2
              (f32.const 0)
              (f32.const -1)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max2
              (f32.const -1)
              (f32.const 0)
            )
            (f32.const 0)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max2
              (f32.const 0)
              (f32.const 1)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max2
              (f32.const 1)
              (f32.const 0)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max2
              (f32.const -1)
              (f32.const 1)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f32.ne
            (call $float_max2
              (f32.const 1)
              (f32.const -1)
            )
            (f32.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min1
              (f64.const 0)
              (f64.const -1)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min1
              (f64.const -1)
              (f64.const 0)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min1
              (f64.const 0)
              (f64.const 1)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min1
              (f64.const 1)
              (f64.const 0)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min1
              (f64.const -1)
              (f64.const 1)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min1
              (f64.const 1)
              (f64.const -1)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max1
              (f64.const 0)
              (f64.const -1)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max1
              (f64.const -1)
              (f64.const 0)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max1
              (f64.const 0)
              (f64.const 1)
            )
            (f64.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max1
              (f64.const 1)
              (f64.const 0)
            )
            (f64.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max1
              (f64.const -1)
              (f64.const 1)
            )
            (f64.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max1
              (f64.const 1)
              (f64.const -1)
            )
            (f64.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min2
              (f64.const 0)
              (f64.const -1)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min2
              (f64.const -1)
              (f64.const 0)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min2
              (f64.const 0)
              (f64.const 1)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min2
              (f64.const 1)
              (f64.const 0)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min2
              (f64.const -1)
              (f64.const 1)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_min2
              (f64.const 1)
              (f64.const -1)
            )
            (f64.const -1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max2
              (f64.const 0)
              (f64.const -1)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max2
              (f64.const -1)
              (f64.const 0)
            )
            (f64.const 0)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max2
              (f64.const 0)
              (f64.const 1)
            )
            (f64.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max2
              (f64.const 1)
              (f64.const 0)
            )
            (f64.const 1)
          )
        )
        (br_if $label$1
          (f64.ne
            (call $double_max2
              (f64.const -1)
              (f64.const 1)
            )
            (f64.const 1)
          )
        )
        (br_if $label$0
          (f64.eq
            (call $double_max2
              (f64.const 1)
              (f64.const -1)
            )
            (f64.const 1)
          )
        )
      )
      (call_import $abort)
      (unreachable)
    )
    (call_import $exit
      (i32.const 0)
    )
    (unreachable)
  )
)
